Index: external/fastjet/RectangularGrid.hh
===================================================================
--- external/fastjet/RectangularGrid.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/RectangularGrid.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -0,0 +1,172 @@
+#ifndef __FASTJET_RECTANGULARGRID_HH__
+#define __FASTJET_RECTANGULARGRID_HH__
+
+//FJSTARTHEADER
+// $Id$
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet.
+//
+//  FastJet is free software; you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation; either version 2 of the License, or
+//  (at your option) any later version.
+//
+//  The algorithms that underlie FastJet have required considerable
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
+//  FastJet as part of work towards a scientific publication, please
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
+//
+//  FastJet is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+//FJENDHEADER
+
+#include "fastjet/PseudoJet.hh"
+#include "fastjet/Selector.hh"
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+
+//----------------------------------------------------------------------
+/// Class to indicate generic structure of tilings
+class TilingBase {
+public:
+  /// returns the index of the tile in which p is located, or -1 if p
+  /// is outside the tiling region
+  virtual int tile_index(const PseudoJet & p) const = 0;
+
+  /// returns the total number of tiles in the tiling; valid tile
+  /// indices run from 0 ... n_tiles()-1;
+  virtual int n_tiles() const = 0;
+
+  /// returns the number of tiles that are "good"; i.e. there is scope
+  /// for having tiles that, for whatever reason, should be ignored;
+  /// there are situations in which having "non-good" tiles may be the
+  /// simplest mechanism to obtain a tiling with holes in it
+  virtual int n_good_tiles() const {return n_tiles();}
+
+  /// returns whether a given tile is good
+  virtual bool tile_is_good(int /* itile */) const {return true;}
+
+  /// returns whether all tiles are good
+  virtual bool all_tiles_good() const {return n_good_tiles() == n_tiles();}
+
+  /// returns true if all tiles have the same area
+  virtual bool all_tiles_equal_area() const {return true;}
+
+  /// returns the area of tile itile. Here with a default
+  /// implementation to return mean_tile_area(), consistent with the
+  /// fact that all_tiles_equal_area() returns true.
+  virtual double tile_area(int /* itile */) const {return mean_tile_area();}
+
+  /// returns the mean area of the tiles.
+  virtual double mean_tile_area() const = 0;
+
+  /// returns a string to describe the tiling
+  virtual std::string description() const = 0;
+
+  /// returns true if the Tiling structure is in a suitably initialised state
+  virtual bool is_initialised() const = 0;
+  bool is_initialized() const {return is_initialised();}
+};
+
+//----------------------------------------------------------------------
+/// Class that holds a generic rectangular tiling
+class RectangularGrid : public TilingBase {
+public:
+  /// ctor with simple initialisation
+  ///  \param rapmax     the maximal absolute rapidity extent of the grid
+  ///  \param cell_size  the grid spacing (equivalently, cell size)
+  RectangularGrid(double rapmax, double cell_size) :
+      _ymax(rapmax), _ymin(-rapmax), 
+      _requested_drap(cell_size), _requested_dphi(cell_size) {
+    _setup_grid();
+  }
+
+  /// ctor with more control over initialisation
+  ///  \param rapmin         the minimum rapidity extent of the grid
+  ///  \param rapmax         the maximum rapidity extent of the grid
+  ///  \param drap           the grid spacing in rapidity
+  ///  \param dphi           the grid spacing in azimuth
+  ///  \param tile_selector  optional (geometric) selector to specify 
+  ///                        which tiles are good; a tile is good if
+  ///                        a massless 4-vector at the center of the tile passes
+  ///                        the selection
+  RectangularGrid(double rapmin, double rapmax, double drap, double dphi,
+                  Selector tile_selector = Selector()) 
+    : _ymax(rapmax), _ymin(rapmin), 
+      _requested_drap(drap), _requested_dphi(dphi),
+      _tile_selector(tile_selector)
+  {
+    _setup_grid();
+  }
+
+  /// dummy ctor (will give an unusable grid)
+  RectangularGrid();
+
+  virtual int n_tiles() const {return _ntotal;}
+
+  virtual int n_good_tiles() const {return _ngood;}
+
+  // this was being kept inline, but it seems to make little
+  // difference whether it is or not (at least on Gavin's mac)
+  virtual int tile_index(const PseudoJet & p) const;
+
+  /// returns whether a given tile is good
+  // tested in "issue" 2014-08-08-testing-rect-grid
+  virtual bool tile_is_good(int itile) const {return _tile_selector.worker() ? _is_good[itile] : true;}
+
+  /// returns the area of tile itile.
+  virtual double tile_area(int /* itile */) const {return mean_tile_area();}
+
+  /// returns the mean area of tiles.
+  virtual double mean_tile_area() const {return _dphi*_dy;};
+
+  /// returns a textual description of the grid
+  virtual std::string description() const;
+  
+  /// returns the minimum rapidity extent of the grid
+  double rapmin() const {return _ymin;}
+  /// returns the maxmium rapidity extent of the grid
+  double rapmax() const {return _ymax;}
+  /// returns the spacing of the grid in rapidity
+  double drap()   const {return _dy;}
+  /// returns the spacing of the grid in azimuth
+  double dphi()   const {return _dphi;}
+
+  /// returns true if the grid is in a suitably initialised state
+  virtual bool is_initialised() const {return _ntotal > 0;}
+
+private:
+  void _setup_grid();
+  
+  // information about the requested grid
+  double _ymax, _ymin;  ///< maximal and minimal rapidity coverage of the grid
+  double _requested_drap; ///< requested rapidity spacing
+  double _requested_dphi; ///< requested phi spacing
+
+  // information about the actual grid
+  double _dy, _dphi, _cell_area, _inverse_dy, _inverse_dphi;
+  int _ny, _nphi, _ntotal;
+  int _ngood;
+
+  // a tile selector
+  Selector _tile_selector;
+  // a cached 
+  std::vector<bool> _is_good;
+  
+};
+
+FASTJET_END_NAMESPACE        // defined in fastjet/internal/base.hh
+
+#endif // __FASTJET_RECTANGULARGRID_HH__
Index: external/fastjet/Selector.cc
===================================================================
--- external/fastjet/Selector.cc	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/Selector.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id$
+//FJSTARTHEADER
+// $Id: Selector.cc 3504 2014-08-01 06:07:54Z soyez $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
@@ -95,4 +97,54 @@
 }
 
+//----------------------------------------------------------------------
+// sum the momenta of the jets that pass the cuts
+PseudoJet Selector::sum(const std::vector<PseudoJet> & jets) const {
+  PseudoJet this_sum(0,0,0,0);
+  const SelectorWorker * worker_local = validated_worker();
+  
+  // separate strategies according to whether the worker applies jet by jet
+  if (worker_local->applies_jet_by_jet()) {
+    for (unsigned i = 0; i < jets.size(); i++) {
+      if (worker_local->pass(jets[i])) this_sum += jets[i];
+    }
+  } else {
+    std::vector<const PseudoJet *> jetptrs(jets.size());
+    for (unsigned i = 0; i < jets.size(); i++) {
+      jetptrs[i] = & jets[i];
+    }
+    worker_local->terminator(jetptrs);
+    for (unsigned i = 0; i < jetptrs.size(); i++) {
+      if (jetptrs[i]) this_sum += jets[i];
+    }
+  }
+
+  return this_sum;
+}
+
+//----------------------------------------------------------------------
+// sum the (scalar) pt of the jets that pass the cuts
+double Selector::scalar_pt_sum(const std::vector<PseudoJet> & jets) const {
+  double this_sum = 0.0;
+  const SelectorWorker * worker_local = validated_worker();
+  
+  // separate strategies according to whether the worker applies jet by jet
+  if (worker_local->applies_jet_by_jet()) {
+    for (unsigned i = 0; i < jets.size(); i++) {
+      if (worker_local->pass(jets[i])) this_sum += jets[i].pt();
+    }
+  } else {
+    std::vector<const PseudoJet *> jetptrs(jets.size());
+    for (unsigned i = 0; i < jets.size(); i++) {
+      jetptrs[i] = & jets[i];
+    }
+    worker_local->terminator(jetptrs);
+    for (unsigned i = 0; i < jetptrs.size(); i++) {
+      if (jetptrs[i]) this_sum += jets[i].pt();
+    }
+  }
+
+  return this_sum;
+}
+
 
 //----------------------------------------------------------------------
@@ -1055,5 +1107,5 @@
 class SW_Circle : public SW_WithReference {
 public:
-  SW_Circle(const double &radius) : _radius2(radius*radius) {}
+  SW_Circle(const double radius) : _radius2(radius*radius) {}
 
   /// return a copy of the current object
@@ -1100,5 +1152,5 @@
 
 // select on objets within a distance 'radius' of a variable location
-Selector SelectorCircle(const double & radius) {
+Selector SelectorCircle(const double radius) {
   return Selector(new SW_Circle(radius));
 }
@@ -1110,5 +1162,5 @@
 class SW_Doughnut : public SW_WithReference {
 public:
-  SW_Doughnut(const double &radius_in, const double &radius_out)
+  SW_Doughnut(const double radius_in, const double radius_out)
     : _radius_in2(radius_in*radius_in), _radius_out2(radius_out*radius_out) {}
 
@@ -1159,5 +1211,5 @@
 
 // select on objets with distance from the centre is between 'radius_in' and 'radius_out' 
-Selector SelectorDoughnut(const double & radius_in, const double & radius_out) {
+Selector SelectorDoughnut(const double radius_in, const double radius_out) {
   return Selector(new SW_Doughnut(radius_in, radius_out));
 }
@@ -1168,5 +1220,5 @@
 class SW_Strip : public SW_WithReference {
 public:
-  SW_Strip(const double &delta) : _delta(delta) {}
+  SW_Strip(const double delta) : _delta(delta) {}
 
   /// return a copy of the current object
@@ -1213,5 +1265,5 @@
 
 // select on objets within a distance 'radius' of a variable location
-Selector SelectorStrip(const double & half_width) {
+Selector SelectorStrip(const double half_width) {
   return Selector(new SW_Strip(half_width));
 }
@@ -1224,5 +1276,5 @@
 class SW_Rectangle : public SW_WithReference {
 public:
-  SW_Rectangle(const double &delta_rap, const double &delta_phi)
+  SW_Rectangle(const double delta_rap, const double delta_phi)
     : _delta_rap(delta_rap),  _delta_phi(delta_phi) {}
 
@@ -1270,5 +1322,5 @@
 
 // select on objets within a distance 'radius' of a variable location
-Selector SelectorRectangle(const double & half_rap_width, const double & half_phi_width) {
+Selector SelectorRectangle(const double half_rap_width, const double half_phi_width) {
   return Selector(new SW_Rectangle(half_rap_width, half_phi_width));
 }
Index: external/fastjet/Selector.hh
===================================================================
--- external/fastjet/Selector.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/Selector.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -2,8 +2,8 @@
 #define __FASTJET_SELECTOR_HH__
 
-//STARTHEADER
-// $Id: Selector.hh 3203 2013-09-15 07:49:50Z salam $
-//
-// Copyright (c) 2009-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//FJSTARTHEADER
+// $Id: Selector.hh 3504 2014-08-01 06:07:54Z soyez $
+//
+// Copyright (c) 2009-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -16,7 +16,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -28,5 +30,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 #include "fastjet/PseudoJet.hh"
@@ -67,12 +69,17 @@
   //----------------------------------------------------------
 
-  /// returns true if a given object passes the selection criterion.
-  /// This has to be overloaded by derived workers
+  /// returns true if a given object passes the selection criterion,
+  /// and is the main function that needs to be overloaded by derived
+  /// workers. 
+  ///
+  /// NB: this function is used only if applies_jet_by_jet() returns
+  /// true. If it does not, then derived classes are expected to
+  /// (re)implement the terminator function()
   virtual bool pass(const PseudoJet & jet) const = 0;
 
   /// For each jet that does not pass the cuts, this routine sets the 
-  /// pointer to 0. 
-  ///
-  /// It does not assume that the PseudoJet* passed as argumetn are not NULL
+  /// pointer to 0.
+  ///
+  /// It does not assume that the PseudoJet* passed as argument are not NULL
   virtual void terminator(std::vector<const PseudoJet *> & jets) const {
     for (unsigned i = 0; i < jets.size(); i++) {
@@ -133,4 +140,5 @@
     throw Error("this selector has no computable area");
   }
+
 };
 
@@ -151,5 +159,4 @@
   Selector(SelectorWorker * worker_in) {_worker.reset(worker_in);}
 
-
 #ifndef __FJCORE__
   /// ctor from a RangeDefinition
@@ -186,4 +193,16 @@
   /// passes and then evaluating the size of the vector
   unsigned int count(const std::vector<PseudoJet> & jets) const;
+
+  /// Return the 4-vector sum of the objects that pass the selection.
+  ///
+  /// This will often be more efficient that getting the vector of objects that
+  /// passes and then evaluating the size of the vector
+  PseudoJet sum(const std::vector<PseudoJet> & jets) const;
+
+  /// Return the scalar pt sum of the objects that pass the selection.
+  ///
+  /// This will often be more efficient that getting the vector of objects that
+  /// passes and then evaluating the size of the vector
+  double scalar_pt_sum(const std::vector<PseudoJet> & jets) const;
 
   /// sift the input jets into two vectors -- those that pass the selector
@@ -433,18 +452,18 @@
 /// select objets within a distance 'radius' from the location of the
 /// reference jet, set by Selector::set_reference(...)
-Selector SelectorCircle(const double & radius); 
+Selector SelectorCircle(const double radius); 
 
 /// select objets with distance from the reference jet is between 'radius_in'
 /// and 'radius_out'; the reference jet is set by Selector::set_reference(...)
-Selector SelectorDoughnut(const double & radius_in, const double & radius_out); 
+Selector SelectorDoughnut(const double radius_in, const double radius_out); 
 
 /// select objets within a rapidity distance 'half_width' from the
 /// location of the reference jet, set by Selector::set_reference(...)
-Selector SelectorStrip(const double & half_width);
+Selector SelectorStrip(const double half_width);
 
 /// select objets within rapidity distance 'half_rap_width' from the
 /// reference jet and azimuthal-angle distance within 'half_phi_width'; the
 /// reference jet is set by Selector::set_reference(...)
-Selector SelectorRectangle(const double & half_rap_width, const double & half_phi_width);
+Selector SelectorRectangle(const double half_rap_width, const double half_phi_width);
 
 
Index: external/fastjet/SharedPtr.hh
===================================================================
--- external/fastjet/SharedPtr.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/SharedPtr.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -2,8 +2,8 @@
 #define __FASTJET_SHARED_PTR_HH__
 
-//STARTHEADER
-// $Id: SharedPtr.hh 3129 2013-06-05 08:48:36Z salam $
-//
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//FJSTARTHEADER
+// $Id: SharedPtr.hh 3433 2014-07-23 08:17:03Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -16,7 +16,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -28,5 +30,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 #include "fastjet/internal/base.hh"
Index: external/fastjet/TilingExtent.cc
===================================================================
--- external/fastjet/TilingExtent.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/TilingExtent.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -0,0 +1,152 @@
+//FJSTARTHEADER
+// $Id: TilingExtent.cc 3433 2014-07-23 08:17:03Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet.
+//
+//  FastJet is free software; you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation; either version 2 of the License, or
+//  (at your option) any later version.
+//
+//  The algorithms that underlie FastJet have required considerable
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
+//  FastJet as part of work towards a scientific publication, please
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
+//
+//  FastJet is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+//FJENDHEADER
+
+#include <iomanip>
+#include <limits>
+#include <cmath>
+#include "fastjet/internal/TilingExtent.hh"
+using namespace std;
+
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+TilingExtent::TilingExtent(ClusterSequence & cs) {
+  _determine_rapidity_extent(cs.jets());
+}
+  
+void TilingExtent::_determine_rapidity_extent(const vector<PseudoJet> & particles) {
+  // have a binning of rapidity that goes from -nrap to nrap
+  // in bins of size 1; the left and right-most bins include
+  // include overflows from smaller/larger rapidities
+  int nrap = 20; 
+  int nbins = 2*nrap;
+  vector<double> counts(nbins, 0);
+  
+  // get the minimum and maximum rapidities and at the same time bin
+  // the multiplicities as a function of rapidity to help decide how
+  // far out it's worth going
+  _minrap =  numeric_limits<double>::max();
+  _maxrap = -numeric_limits<double>::max();
+  int ibin;
+  for (unsigned i = 0; i < particles.size(); i++) {
+    // ignore particles with infinite rapidity
+    if (particles[i].E() == abs(particles[i].pz())) continue;
+    double rap = particles[i].rap();
+    if (rap < _minrap) _minrap = rap;
+    if (rap > _maxrap) _maxrap = rap;
+    // now bin the rapidity to decide how far to go with the tiling.
+    // Remember the bins go from ibin=0 (rap=-infinity..-19)
+    // to ibin = nbins-1 (rap=19..infinity for nrap=20)
+    ibin = int(rap+nrap); 
+    if (ibin < 0) ibin = 0;
+    if (ibin >= nbins) ibin = nbins - 1;
+    counts[ibin]++;
+  }
+
+  // now figure out the particle count in the busiest bin
+  double max_in_bin = 0;
+  for (ibin = 0; ibin < nbins; ibin++) {
+    if (max_in_bin < counts[ibin]) max_in_bin = counts[ibin];
+  }
+  
+  // and find _minrap, _maxrap such that edge bin never contains more
+  // than some fraction of busiest, and at least a few particles; first do
+  // it from left. NB: the thresholds chosen here are largely
+  // guesstimates as to what might work.
+  //
+  // 2014-07-17: in some tests at high multiplicity (100k) and particles going up to
+  //             about 7.3, anti-kt R=0.4, we found that 0.25 gave 20% better run times
+  //             than the original value of 0.5.
+  const double allowed_max_fraction = 0.25;
+  // the edge bins should also contain at least min_multiplicity particles
+  const double min_multiplicity = 4;
+  // now calculate how much we can accumulate into an edge bin
+  double allowed_max_cumul = floor(max(max_in_bin * allowed_max_fraction, min_multiplicity));
+  // make sure we don't require more particles in a bin than max_in_bin
+  if (allowed_max_cumul > max_in_bin) allowed_max_cumul = max_in_bin;
+
+  // start scan over rapidity bins from the left, to find out minimum rapidity of tiling
+  double cumul_lo = 0;
+  _cumul2 = 0;
+  for (ibin = 0; ibin < nbins; ibin++) {
+    cumul_lo += counts[ibin];
+    if (cumul_lo >= allowed_max_cumul) {
+      double y = ibin-nrap;
+      if (y > _minrap) _minrap = y;
+      break;
+    }
+  }
+  assert(ibin != nbins); // internal consistency check that you found a bin
+  _cumul2 += cumul_lo*cumul_lo;
+
+  // ibin_lo is the index of the leftmost bin that should be considered
+  int ibin_lo = ibin;
+
+  // then do it from right, to find out maximum rapidity of tiling
+  double cumul_hi = 0;
+  for (ibin = nbins-1; ibin >= 0; ibin--) {
+    cumul_hi += counts[ibin];
+    if (cumul_hi >= allowed_max_cumul) {
+      double y = ibin-nrap+1; // +1 here is the rapidity bin width
+      if (y < _maxrap) _maxrap = y;
+      break;
+    }
+  }
+  assert(ibin >= 0); // internal consistency check that you found a bin
+
+  // ibin_hi is the index of the rightmost bin that should be considered
+  int ibin_hi = ibin;
+
+  // consistency check 
+  assert(ibin_hi >= ibin_lo); 
+
+  // now work out cumul2
+  if (ibin_hi == ibin_lo) {
+    // if there is a single bin (potentially including overflows
+    // from both sides), cumul2 is the square of the total contents
+    // of that bin, which we obtain from cumul_lo and cumul_hi minus
+    // the double counting of part that is contained in both
+    // (putting double 
+    _cumul2 = pow(double(cumul_lo + cumul_hi - counts[ibin_hi]), 2);
+  } else {
+    // otherwise we have a straightforward sum of squares of bin
+    // contents
+    _cumul2 += cumul_hi*cumul_hi;
+
+    // now get the rest of the squared bin contents
+    for (ibin = ibin_lo+1; ibin < ibin_hi; ibin++) {
+      _cumul2 += counts[ibin]*counts[ibin];
+    }
+  }
+
+}
+
+
+FASTJET_END_NAMESPACE
Index: external/fastjet/VERSION
===================================================================
--- external/fastjet/VERSION	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/VERSION	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,1 +1,1 @@
-3.0.6
+3.1.0-beta.1
Index: external/fastjet/Voronoi.cc
===================================================================
--- external/fastjet/Voronoi.cc	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/Voronoi.cc	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,26 +1,31 @@
-//STARTHEADER
-// $Id$
+//FJSTARTHEADER
+// $Id: Voronoi.cc 3433 2014-07-23 08:17:03Z salam $
 //
-// Copyright (c) 1994 by AT&T Bell Laboratories (see below)
-//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
-// This file is included as part of FastJet but was mostly written by
-// S. Fortune in C, put into C++ with memory management by S
-// O'Sullivan, and with further interface and memory management
-// modifications by Gregory Soyez.
+// This file is part of FastJet.
 //
-// Permission to use, copy, modify, and distribute this software for
-// any purpose without fee is hereby granted, provided that this
-// entire notice is included in all copies of any software which is or
-// includes a copy or modification of this software and in all copies
-// of the supporting documentation for such software. THIS SOFTWARE IS
-// BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED WARRANTY.
-// IN PARTICULAR, NEITHER THE AUTHORS NOR AT&T MAKE ANY REPRESENTATION
-// OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY OF THIS
-// SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
+//  FastJet is free software; you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation; either version 2 of the License, or
+//  (at your option) any later version.
 //
+//  The algorithms that underlie FastJet have required considerable
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
+//  FastJet as part of work towards a scientific publication, please
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
+//
+//  FastJet is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
Index: external/fastjet/WrappedStructure.hh
===================================================================
--- external/fastjet/WrappedStructure.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/WrappedStructure.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id: WrappedStructure.hh 2577 2011-09-13 15:11:38Z salam $
-//
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//FJSTARTHEADER
+// $Id: WrappedStructure.hh 3433 2014-07-23 08:17:03Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
Index: external/fastjet/config_auto.h
===================================================================
--- external/fastjet/config_auto.h	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/config_auto.h	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -147,5 +147,5 @@
 /* Define to the full name and version of this package. */
 #ifndef FASTJET_PACKAGE_STRING 
-#define FASTJET_PACKAGE_STRING  "FastJet 3.0.6" 
+#define FASTJET_PACKAGE_STRING  "FastJet 3.1.0-beta.1" 
 #endif
 
@@ -157,5 +157,5 @@
 /* Define to the version of this package. */
 #ifndef FASTJET_PACKAGE_VERSION 
-#define FASTJET_PACKAGE_VERSION  "3.0.6" 
+#define FASTJET_PACKAGE_VERSION  "3.1.0-beta.1" 
 #endif
 
@@ -167,5 +167,30 @@
 /* Version number of package */
 #ifndef FASTJET_VERSION 
-#define FASTJET_VERSION  "3.0.6" 
+#define FASTJET_VERSION  "3.1.0-beta.1" 
+#endif
+
+/* Major version of this package */
+#ifndef FASTJET_VERSION_MAJOR 
+#define FASTJET_VERSION_MAJOR  3 
+#endif
+
+/* Minor version of this package */
+#ifndef FASTJET_VERSION_MINOR 
+#define FASTJET_VERSION_MINOR  1 
+#endif
+
+/* Version of the package under the form XYYZZ (instead of X.Y.Z) */
+#ifndef FASTJET_VERSION_NUMBER 
+#define FASTJET_VERSION_NUMBER  30103 
+#endif
+
+/* Patch version of this package */
+#ifndef FASTJET_VERSION_PATCHLEVEL 
+#define FASTJET_VERSION_PATCHLEVEL  3 
+#endif
+
+/* Pre-release version of this package */
+#ifndef FASTJET_VERSION_PRERELEASE 
+#define FASTJET_VERSION_PRERELEASE  ".1.0-beta.1" 
 #endif
  
